Annotation of openbsd/fw_update/fw_install.sh, Revision 1.39
1.1 afresh1 1: #!/bin/ksh
1.36 afresh1 2: # $OpenBSD$
1.1 afresh1 3: set -e
4:
1.38 afresh1 5: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
6: #
7: # Permission to use, copy, modify, and distribute this software for any
8: # purpose with or without fee is hereby granted, provided that the above
9: # copyright notice and this permission notice appear in all copies.
10: #
11: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
18:
1.24 afresh1 19: # Fake up some things from install.sub that we don't need to actually do
1.22 afresh1 20: prefetcharea_fs_list() {
1.27 afresh1 21: echo "${DESTDIR}/tmp"
1.22 afresh1 22: }
23:
1.8 afresh1 24: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
25:
26: # Create a temporary directory based on the supplied directory name prefix.
27: tmpdir() {
28: local _i=1 _dir
29:
30: until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
31: ((++_i < 10000)) || return 1
32: done
33: echo "$_dir"
34: }
1.6 afresh1 35:
36: # Run a command ($2+) as unprivileged user ($1).
37: # Take extra care that after "cmd" no "user" processes exist.
38: #
39: # Optionally:
40: # - create "file" and chown it to "user"
41: # - after "cmd", chown "file" back to root
42: #
43: # Usage: do_as user [-f file] cmd
44: do_as() {
45: (( $# >= 2 )) || return
46:
47: local _file _rc _user=$1
48: shift
49:
50: if [[ $1 == -f ]]; then
51: _file=$2
52: shift 2
53: fi
54:
55: if [[ -n $_file ]]; then
56: >$_file
57: chown "$_user" "$_file"
58: fi
59:
60: doas -u "$_user" "$@"
61: _rc=$?
62:
63: while doas -u "$_user" kill -9 -1 2>/dev/null; do
64: echo "Processes still running for user $_user after: $@"
65: sleep 1
66: done
67:
68: [[ -n $_file ]] && chown root "$_file"
69:
70: return $_rc
71: }
72:
73: unpriv() {
74: do_as _sndio "$@"
75: }
76:
77: unpriv2() {
78: do_as _file "$@"
79: }
80:
1.33 afresh1 81: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
1.34 afresh1 82: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
1.33 afresh1 83: FWDIR=${FWDIR:-$VNAME}
1.29 afresh1 84: MODE=${MODE:-install}
1.1 afresh1 85:
1.14 afresh1 86: # TODO: We need the firmware for the system we just installed
87: # not the one we booted from. For example:
88: # * booting from a snapshot bsd.rd that thinks it is the 7.0 release
89: # will install the firmware from the 7.0 directory instead of
90: # from the snapshots dir.
91: # If they're using sysupgrade, then the installer kernel will be correct.
92: # If we're doing this in the installer we can check what they picked
93: # for downloading sets and use that value.
94: # Otherwise, the fw_update after first boot will fix it up for us.
95:
1.7 afresh1 96: HTTP_FWDIR=$FWDIR
1.30 afresh1 97: set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
1.7 afresh1 98: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
99:
100: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
101: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.37 afresh1 102: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
1.1 afresh1 103:
1.20 afresh1 104: # TODO: support srclocal installation of firmware somehow
1.35 afresh1 105: fw_install() {
1.24 afresh1 106: local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
1.27 afresh1 107: _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
1.25 afresh1 108: _f _r _remove _i _installed
109: local _srclocal=false _unpriv=unpriv
1.26 afresh1 110:
111: echo "Let's $MODE firmware!"
1.15 afresh1 112: local _d _drivers=$(
1.11 afresh1 113: last=''
1.15 afresh1 114: while read _d _m; do
1.11 afresh1 115: grep=grep
1.15 afresh1 116: [ "$last" = "$_d" ] && continue
117: [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
118: [ "$_m" = "${_m#^}" ] && grep=fgrep
119: $grep -q "$_m" /var/run/dmesg.boot || continue
120: echo $_d
121: last=$_d
1.37 afresh1 122: done < $FWPATTERNS
1.11 afresh1 123: )
124:
125: if [ -z "$_drivers" ]; then
1.22 afresh1 126: echo "No devices found which need firmware files to be downloaded."
1.11 afresh1 127: return
128: fi
1.1 afresh1 129:
1.22 afresh1 130: ! _tmpfs_list=$(prefetcharea_fs_list) &&
131: echo "Cannot determine prefetch area" >&2 && return
132:
133: for _tmpfs in $_tmpfs_list; do
134: # Try to clean up from previous runs, assuming
135: # the _tmpfs selection yields the same mount
136: # point.
137: for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
138: [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
139: done
140:
141: # Create a download directory for the firmware and
142: # check that the _sndio user can read files from
143: # it. Otherwise cleanup and skip the filesystem.
144: if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then
145: (
146: >$_tmpsrc/t &&
147: $_unpriv cat $_tmpsrc/t
148: ) >/dev/null 2>&1 && break ||
149: rm -r $_tmpsrc
150: fi
151: done
1.1 afresh1 152:
1.11 afresh1 153: [[ ! -d $_tmpsrc ]] &&
1.22 afresh1 154: echo "Cannot create prefetch area" >&2 && return 1
1.1 afresh1 155:
1.16 afresh1 156: # Cleanup from previous runs.
157: rm -f $_cfile $_cfile.sig
158:
1.21 afresh1 159: _t=Get/Verify
1.17 afresh1 160:
1.11 afresh1 161: ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
1.22 afresh1 162: echo "Cannot fetch SHA256.sig" >&2 && return 1
1.1 afresh1 163:
1.11 afresh1 164: # Verify signature file with public keys.
1.24 afresh1 165: ! $_unpriv -f "$_cfile" \
1.11 afresh1 166: signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
1.22 afresh1 167: echo "Signature check of SHA256.sig failed" >&2 && return 1
1.11 afresh1 168:
1.15 afresh1 169: for _d in $_drivers; do
1.39 ! afresh1 170: _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" | tail -1 )
1.19 afresh1 171: _installed=$(
1.22 afresh1 172: for fw in "${_pkgdir}/$_d-firmware"*; do
1.19 afresh1 173: [ -e "$fw" ] || continue
174: echo ${fw##*/}
175: done
1.21 afresh1 176: )
1.15 afresh1 177:
178: for _i in $_installed; do
179: if [ "$_f" = "$_i.tgz" ]; then
1.24 afresh1 180: echo "$_i already installed"
1.11 afresh1 181: continue 2
1.1 afresh1 182: fi
183: done
184:
1.11 afresh1 185: rm -f /tmp/h /tmp/fail
186:
187: # Fetch firmware file and create a checksum by piping through
188: # sha256. Create a flag file in case ftp failed. Firmware
189: # from net is written to the prefetch area.
190: ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
191: ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
192: unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
193:
194: # Handle failed transfer.
195: if [[ -f /tmp/fail ]]; then
196: rm -f "$_tmpsrc/$_f"
1.22 afresh1 197: echo "Fetching of $_f failed!" >&2
198: continue
1.11 afresh1 199: fi
200:
201: # Verify firmware by comparing its checksum with SHA256.
1.22 afresh1 202: if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
1.11 afresh1 203: [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
1.22 afresh1 204: echo "Checksum test for $_f failed." >&2
205: continue
1.11 afresh1 206: fi
207:
208: # TODO: Check hash for files before deleting
1.22 afresh1 209: if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
1.18 afresh1 210: echo "Uninstalling $_installed"
1.22 afresh1 211: cwd=${_pkgdir}/$_installed
1.11 afresh1 212:
213: set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
214:
215: while read c g; do
216: case $c in
1.27 afresh1 217: @cwd) cwd="${DESTDIR}/$g"
1.11 afresh1 218: ;;
219: @*) continue
220: ;;
221: *) set -A _remove -- "$cwd/$c" "${_remove[@]}"
222: ;;
223: esac
1.22 afresh1 224: done < "${_pkgdir}/$_installed/+CONTENTS"
1.11 afresh1 225:
1.21 afresh1 226: # We specifically rm -f here because not removing files/dirs
227: # is probably not worth failing over.
1.11 afresh1 228: for _r in "${_remove[@]}" ; do
229: if [ -d "$_r" ]; then
230: # Try hard not to actually remove recursively
231: # without rmdir on the install media.
232: [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
233: else
234: rm -f "$_r"
235: fi
236: done
237: fi
238:
1.21 afresh1 239: # TODO: Should we mark these so real fw_update can -Drepair?
1.25 afresh1 240: ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
241: tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
1.28 afresh1 242: -s ",^firmware,${DESTDIR}/etc/firmware," \
1.25 afresh1 243: -C / -zxphf - "+*" "firmware/*"
1.23 afresh1 244:
1.22 afresh1 245: ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
1.1 afresh1 246: /^@comment pkgpath/ -1a
247: @option manual-installation
248: @option firmware
249: @comment install-script
250: .
251: w
252: EOL
1.11 afresh1 253: done
254: }
1.1 afresh1 255:
1.35 afresh1 256: fw_install "$FWURL"
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>